import deimos.arrays;
import deimos.rangeset;
import deimos.base;

private instance TRangeSet(char).RangeSet vowels;
int isMemberOf(char c) {
    return vowels.contains(c);
}
int main(char[][] args) {
    instance TArrays(char) arrays;
    vowels = new instance TRangeSet(char).RangeSet("aeiouAEIOU");
    if (args.length < 2) {
        printf("usage test <phrase>\r\n");
        return 0;
    }
    instance TArrays(char[]) arrays2;
    char[] phrase = arrays.join(arrays2.rest(args), " ");
    printf("The phrase is '%.*s'\r\n", phrase);
    printf("all vowels? %.*s\r\n", asString(arrays.all(phrase, &isMemberOf)));
    printf("any vowels? %.*s\r\n", asString(arrays.any(phrase, &isMemberOf)));
    printf("count of vowels? %d\r\n", arrays.count(phrase, &isMemberOf));
    return 0;
}
char[] asString(boolean bool) {
    return cast(char[]) (bool ? "true" : "false");
}
